/******************************************************************************
 *
 * Copyright (C) 1997-2023 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby
 * granted. No representations are made about the suitability of this software
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 * Documents produced by analyze are derivative works derived from the
 * input used in their production; they are not affected by this license.
 *
 */

#ifndef HTMLGEN_H
#define HTMLGEN_H

#include "outputgen.h"
#include "containers.h"

class OutputCodeList;

/** Generator for HTML code fragments */
class HtmlCodeGenerator : public OutputCodeIntf
{
  public:
    HtmlCodeGenerator(TextStream *t,const OGString &relPath);
    HtmlCodeGenerator(TextStream *t);

    void setTextStream(TextStream *t) { m_t = t; }
    void setFileName(const OGString fileName) { m_fileName = fileName; }
    OGString fileName() { return m_fileName; }

    OutputType type() const override { return OutputType::Html; }
    std::unique_ptr<OutputCodeIntf> clone() override { return std::make_unique<HtmlCodeGenerator>(*this); }
    void codify(const OGString &text) override;
    void stripCodeComments(bool b) override;
    void startSpecialComment() override;
    void endSpecialComment() override;
    void setStripIndentAmount(size_t amount) override;
    void writeCodeLink(CodeSymbolType type,
                       const OGString &ref,const OGString &file,
                       const OGString &anchor,const OGString &name,
                       const OGString &tooltip) override;
    void writeTooltip(const OGString &id,
                      const DocLinkInfo &docInfo,
                      const OGString &decl,
                      const OGString &desc,
                      const SourceLinkInfo &defInfo,
                      const SourceLinkInfo &declInfo
                     ) override;
    void writeLineNumber(const OGString &,const OGString &,const OGString &,int, bool) override;
    void startCodeLine(int) override;
    void endCodeLine() override;
    void startFontClass(const OGString &s) override;
    void endFontClass() override;
    void writeCodeAnchor(const OGString &anchor) override;
    void startCodeFragment(const OGString &style) override;
    void endCodeFragment(const OGString &) override;
    void startFold(int,const OGString &,const OGString &) override;
    void endFold() override;

    void setRelativePath(const OGString &path);
  private:
    void _writeCodeLink(const OGString &className,
                        const OGString &ref,const OGString &file,
                        const OGString &anchor,const OGString &name,
                        const OGString &tooltip);
    void _startOpenLine();
    //void docify(const OGString &str);
    TextStream *m_t;
    size_t m_col = 0;
    OGString m_relPath;
    OGString m_fileName;
    bool m_lineOpen = false;
    bool m_stripCodeComments = false;
    bool m_hide = false;
    struct LineInfo
    {
      LineInfo() {}
      LineInfo(const OGString &r,const OGString &f,const OGString &a,int l,bool wa)
        : ref(r), fileName(f), anchor(a), line(l), writeAnchor(wa) {}
      OGString ref;
      OGString fileName;
      OGString anchor;
      int line = -1;
      bool writeAnchor = false;
    };
    LineInfo m_lastLineInfo;
    size_t m_stripIndentAmount = 0;
};

/** Generator for HTML output */
class HtmlGenerator : public OutputGenerator, public OutputGenIntf
{
  public:
    HtmlGenerator();
    HtmlGenerator(const HtmlGenerator &);
    HtmlGenerator &operator=(const HtmlGenerator &);
    HtmlGenerator(HtmlGenerator &&) = delete;
    HtmlGenerator &operator=(HtmlGenerator &&) = delete;
   ~HtmlGenerator();

    static void init();
    static void writeStyleSheetFile(TextStream &t);
    static void writeHeaderFile(TextStream &t, const OGString &cssname);
    static void writeFooterFile(TextStream &t);
    static void writeTabData();
    static void writeSearchInfoStatic(TextStream &t,const OGString &relPath);
    static void writeSearchData(const OGString &dir);
    static void writeSearchPage();
    static void writeExternalSearchPage();
    static OGString writeLogoAsString(const OGString &path);
    static OGString writeSplitBarAsString(const OGString &name,const OGString &relpath,const OGString &allMembersFile);
    static OGString getMathJaxMacros();
    static OGString getNavTreeCss();
    void clearBuffer();

    //---------------------------------------------------------------------

    OutputType type() const override { return OutputType::Html; }
    std::unique_ptr<OutputGenIntf> clone() override { return std::make_unique<HtmlGenerator>(*this); }
    void addCodeGen(OutputCodeList &list) override;
    void cleanup() override;
    void writeDoc(const IDocNodeAST *node,const Definition *,const MemberDef *,int id) override;
    void startFile(const OGString &name,const OGString &manName,const OGString &title,int id, int hierarchyLevel) override;
    void endFile() override;

    void writeFooter(const OGString &navPath) override;
    void writeSearchInfo() override;

    void startIndexSection(IndexSection) override {}
    void endIndexSection(IndexSection) override {}
    void writePageLink(const OGString &,bool) override {}
    void startProjectNumber() override;
    void endProjectNumber() override;
    void writeStyleInfo(int part) override;
    void startTitleHead(const OGString &) override;
    void endTitleHead(const OGString &,const OGString &) override;

    void startParagraph(const OGString &classDef) override;
    void endParagraph() override;
    void writeString(const OGString &text) override;
    void startIndexListItem() override;
    void endIndexListItem() override;
    void startIndexList() override;
    void endIndexList() override;
    void startIndexKey() override;
    void endIndexKey() override;
    void startIndexValue(bool) override;
    void endIndexValue(const OGString &,bool) override;
    void startItemList() override  { m_t << "<ul>\n"; }
    void endItemList() override    { m_t << "</ul>\n"; }
    void startIndexItem(const OGString &ref,const OGString &file) override;
    void endIndexItem(const OGString &ref,const OGString &file) override;
    void docify(const OGString &text) override;

    void writeObjectLink(const OGString &ref,const OGString &file,
                         const OGString &anchor,const OGString &name) override;

    void startTextLink(const OGString &file,const OGString &anchor) override;
    void endTextLink() override;
    void startTypewriter() override { m_t << "<code>"; }
    void endTypewriter() override   { m_t << "</code>"; }
    void startGroupHeader(const OGString &,int) override;
    void endGroupHeader(int) override;
    void startItemListItem() override { m_t << "<li>"; }
    void endItemListItem() override { m_t << "</li>\n"; }

    void startMemberSections() override;
    void endMemberSections() override;
    void startHeaderSection() override;
    void endHeaderSection() override;
    void startMemberHeader(const OGString &, int) override;
    void endMemberHeader() override;
    void startMemberSubtitle() override;
    void endMemberSubtitle() override;
    void startMemberDocList() override;
    void endMemberDocList() override;
    void startMemberList() override;
    void endMemberList() override;
    void startInlineHeader() override;
    void endInlineHeader() override;
    void startAnonTypeScope(int) override {}
    void endAnonTypeScope(int) override {}
    void startMemberItem(const OGString &anchor,MemberItemType,const OGString &inheritId) override;
    void endMemberItem(MemberItemType) override;
    void startMemberTemplateParams() override;
    void endMemberTemplateParams(const OGString &anchor,const OGString &inheritId) override;
    void startCompoundTemplateParams() override;
    void endCompoundTemplateParams() override;

    void startMemberGroupHeader(const OGString &,bool) override;
    void endMemberGroupHeader() override;
    void startMemberGroupDocs() override;
    void endMemberGroupDocs() override;
    void startMemberGroup() override;
    void endMemberGroup(bool) override;

    void insertMemberAlign(bool) override;
    void insertMemberAlignLeft(MemberItemType,bool) override;
    void startMemberDescription(const OGString &anchor,const OGString &inheritId, bool typ) override;
    void endMemberDescription() override;
    void startMemberDeclaration() override {}
    void endMemberDeclaration(const OGString &anchor,const OGString &inheritId) override;
    void writeInheritedSectionTitle(const OGString &id,   const OGString &ref,
                                    const OGString &file, const OGString &anchor,
                                    const OGString &title,const OGString &name) override;

    void writeRuler() override    { m_t << "<hr/>"; }
    void writeAnchor(const OGString &,const OGString &name)
                        override  { m_t << "<a name=\"" << name <<"\" id=\"" << name << "\"></a>"; }
    void startEmphasis() override { m_t << "<em>";  }
    void endEmphasis() override   { m_t << "</em>"; }
    void startBold() override     { m_t << "<b>"; }
    void endBold() override       { m_t << "</b>"; }
    void startDescForItem() override { m_t << "<dd>"; }
    void endDescForItem() override   { m_t << "</dd>\n"; }
    void lineBreak(const OGString &style) override;
    void writeChar(char c) override;
    void startMemberDoc(const OGString &clName, const OGString &memName,
                        const OGString &anchor, const OGString &title,
                        int memCount, int memTotal, bool showInline) override;
    void endMemberDoc(bool) override;
    void startanalzAnchor(const OGString &fName,const OGString &manName,
                         const OGString &anchor,const OGString &name,
                         const OGString &args) override;
    void endanalzAnchor(const OGString &fName,const OGString &anchor) override;
    void addLabel(const OGString &,const OGString &) override;
    void writeLatexSpacing() override {}
    void writeStartAnnoItem(const OGString &type,const OGString &file,
                            const OGString &path,const OGString &name) override;
    void startCenter() override        { m_t << "<center>\n"; }
    void endCenter() override          { m_t << "</center>\n"; }
    void startSmall() override         { m_t << "<small>\n"; }
    void endSmall() override           { m_t << "</small>\n"; }
    void startExamples() override;
    void endExamples() override;
    void startSection(const OGString &,const OGString &,SectionType) override;
    void endSection(const OGString &,SectionType) override;
    void addIndexItem(const OGString &,const OGString &) override;
    void startIndent() override;
    void endIndent() override;
    void writeSynopsis() override {}
    void startClassDiagram() override;
    void endClassDiagram(const ClassDiagram &,const OGString &,const OGString &) override;
    void startPageRef() override {}
    void endPageRef(const OGString &,const OGString &) override {}
    void startQuickIndices() override {}
    void endQuickIndices() override;
    void writeSplitBar(const OGString &name,const OGString &allMembersFile) override;
    void writeNavigationPath(const OGString &s) override;
    void writeLogo() override;
    void writeQuickLinks(HighlightedItem hli,const OGString &file,bool extraTabs) override;
    void writeSummaryLink(const OGString &file,const OGString &anchor,const OGString &title,bool first) override;
    void writePageOutline() override;
    void startContents() override;
    void endContents() override;
    void startPageDoc(const OGString &pageTitle) override;
    void endPageDoc() override;
    void writeNonBreakableSpace(int) override;

    void startDescTable(const OGString &title,const bool hasInits) override;
    void endDescTable() override;
    void startDescTableRow() override;
    void endDescTableRow() override;
    void startDescTableTitle() override;
    void endDescTableTitle() override;
    void startDescTableInit() override;
    void endDescTableInit() override;
    void startDescTableData() override;
    void endDescTableData() override;

    void startDotGraph() override;
    void endDotGraph(DotClassGraph &g) override;
    void startInclDepGraph() override;
    void endInclDepGraph(DotInclDepGraph &g) override;
    void startGroupCollaboration() override;
    void endGroupCollaboration(DotGroupCollaboration &g) override;
    void startCallGraph() override;
    void endCallGraph(DotCallGraph &g) override;
    void startDirDepGraph() override;
    void endDirDepGraph(DotDirDeps &g) override;
    void writeGraphicalHierarchy(DotGfxHierarchyTable &g) override;

    void startTextBlock(bool) override { m_t << "<div class=\"textblock\">"; }
    void endTextBlock(bool) override { m_t << "</div>"; }
    void lastIndexPage() override {}

    void startMemberDocPrefixItem() override;
    void endMemberDocPrefixItem() override;
    void startMemberDocName(bool) override;
    void endMemberDocName() override;
    void startParameterType(bool first,const OGString &key) override;
    void endParameterType() override;
    void startParameterName(bool) override;
    void endParameterName() override;
    void startParameterExtra() override;
    void endParameterExtra(bool last,bool emptyList,bool closeBracket) override;
    void startParameterDefVal(const char *sep) override;
    void endParameterDefVal() override;
    void startParameterList(bool) override;
    void endParameterList() override;
    void exceptionEntry(const OGString &,bool) override;

    void startConstraintList(const OGString &) override;
    void startConstraintParam() override;
    void endConstraintParam() override;
    void startConstraintType() override;
    void endConstraintType() override;
    void startConstraintDocs() override;
    void endConstraintDocs() override;
    void endConstraintList() override;

    void startMemberDocSimple(bool) override;
    void endMemberDocSimple(bool) override;
    void startInlineMemberType() override;
    void endInlineMemberType() override;
    void startInlineMemberName() override;
    void endInlineMemberName() override;
    void startInlineMemberDoc() override;
    void endInlineMemberDoc() override;

    void startLabels() override;
    void writeLabel(const OGString &l,bool isLast) override;
    void endLabels() override;

    void startLocalToc(int level) override;
    void endLocalToc() override;
    void startTocEntry(const SectionInfo *si) override;
    void endTocEntry(const SectionInfo *si) override;

    void startPlainFile(const OGString &name) override { OutputGenerator::startPlainFile(name); }
    void endPlainFile() override { OutputGenerator::endPlainFile(); }

  private:
    void startTitle() { m_t << "<div class=\"title\">"; }
    void endTitle() { m_t << "</div>"; }
    static void writePageFooter(TextStream &t,const OGString &,const OGString &,const OGString &);
    void docify_(const OGString &text,bool inHtmlComment);

    OGString                        m_lastTitle;
    OGString                        m_lastFile;
    OGString                        m_relPath;
    int                             m_sectionCount = 0;
    bool                            m_emptySection = false;
    std::unique_ptr<OutputCodeList> m_codeList;
    HtmlCodeGenerator              *m_codeGen = nullptr;
    int                             m_pageOutlineIndent = 0;

    struct TocState
    {
      int level = 0;
      int indent = 0;
      int maxLevel = 0;
      BoolVector inLi;
      void writeIndent(TextStream &t) { for (int i=0;i<indent*2;i++) t << " "; };
      void incIndent(TextStream &t,const OGString &text) { writeIndent(t); t << text << "\n"; indent++; };
      void decIndent(TextStream &t,const OGString &text) { indent--; writeIndent(t); t << text << "\n"; };
    };
    TocState m_tocState;
};

#endif
